﻿using ProtoBuf;
using System;
using System.Collections.Generic;

namespace Protocols {

    /// <summary>
    /// 二维信息
    /// </summary>
    [ProtoContract]
    public class stVec2 {
        [ProtoMember(1)] public long X = 0;
        [ProtoMember(2)] public long Y = 0;
    }

    ///// <summary>
    ///// 三维信息
    ///// </summary>
    //[ProtoContract]
    //public class stVec3
    //{
    //    [ProtoMember(1)] public long X = 0;
    //    [ProtoMember(2)] public long Y = 0;
    //    [ProtoMember(3)] public long Z = 0;
    //    public stVec3() { }
    //    public stVec3(long x, long y, long z)
    //    {
    //        this.X = x; this.Y = y; this.Z = z;
    //    }
    //    public static stVec3 Zero { get { return new stVec3(0, 0, 0); } }
    //}

    // public class sVec3
    // {
    //     public static stVec3 Zero
    //     {
    //         get
    //         {
    //             stVec3 st = new stVec3();
    //             st.X = st.Y = st.Z = 0;
    //             return st;
    //         }
    //     }
    // }

    /// <summary>
    /// 四维信息
    /// </summary>
    [ProtoContract]
    public class stVec4 {
        [ProtoMember(1)] public long X = 0;
        [ProtoMember(2)] public long Y = 0;
        [ProtoMember(3)] public long Z = 0;
        [ProtoMember(4)] public long W = 0;
    }

    #region 进入世界

    ///// <summary>
    ///// 进入世界请求
    ///// </summary>
    //[ProtoContract]
    //public class EnterWorldReq : ProtoBody {
    //    //世界Id
    //    [ProtoMember(1)] public ulong WorldId = 0;
    //}

    /// <summary>
    /// 进入世界返回
    /// </summary>
    [ProtoContract]
    public class EnterWorldRsp : ProtoBody
    {
        public enum ErrorID
        {
            //成功
            Success = 0,
            //失败
            Failed = 1,
            //不在该世界
            NotInTheWorld = 2,
            //该世界不存在
            WorldNotAlive = 3,
        }
        //[ProtoMember(1)] public ErrorID errorID;
        ////世界Id
        //[ProtoMember(2)] public ulong WorldId = 0;
        ////用户信息
        //[ProtoMember(3)] public stWorldPlayerItem WorldPlayer = new stWorldPlayerItem();
    }

    ///// <summary>
    ///// 进入世界通知
    ///// </summary>
    //[ProtoContract]
    //public class EnterWorldNtf : ProtoBody {
    //    //用户信息
    //    [ProtoMember(1)] public stWorldPlayerItem WorldPlayer = new stWorldPlayerItem();
    //}

    #endregion

    #region 离开世界

    ///// <summary>
    ///// 离开世界请求
    ///// </summary>
    //[ProtoContract]
    //public class ExitWorldReq : ProtoBody {
    //    //世界Id
    //    [ProtoMember(1)] public ulong WorldId = 0;
    //}

    ///// <summary>
    ///// 离开世界返回
    ///// </summary>
    //[ProtoContract]
    public class ExitWorldRsp : ProtoBody
    {
        public enum ErrorID
        {
            //成功
            Success = 0,
            //失败
            Failed = 1,
            //不在该世界
            NotInTheWorld = 2,
            //该世界不存在
            WorldNotAlive = 3,
        }
        //[ProtoMember(1)] public ErrorID errorID;
        ////世界Id
        //[ProtoMember(2)] public ulong WorldId = 0;
    }

    ///// <summary>
    ///// 离开世界通知
    ///// </summary>
    //[ProtoContract]
    //public class ExitWorldNtf : ProtoBody {
    //    //用户信息
    //    [ProtoMember(1)] public ulong userId = 0;
    //}

    #endregion

    #region 世界聊天

    ///// <summary>
    ///// 世界聊天信息条目
    ///// </summary>
    //[ProtoContract]
    //public class stWorldChatItem {
    //    //消息Id
    //    [ProtoMember(1)] public string UuId = string.Empty;
    //    //发送者信息
    //    [ProtoMember(2)] public stSimpleUser UserInfo = new stSimpleUser();
    //    //发送时间
    //    //[ProtoMember(3)] public DateTime SendTime = DateTime.MinValue;
    //    [ProtoMember(3)] public ulong SendTime = 0;
    //    //消息内容
    //    [ProtoMember(4)] public string Content = string.Empty;
    //}

    ///// <summary>
    ///// 获取世界聊天信息请求
    ///// </summary>
    //[ProtoContract]
    //public class GetWorldChatListReq : ProtoBody {
    //    //页码
    //    [ProtoMember(1)] public int Page = 0;
    //    //每页数量
    //    [ProtoMember(2)] public int Count = 0;
    //}

    /// <summary>
    /// 获取世界聊天信息返回
    /// </summary>
    public class GetWorldChatListRsp  {
        public enum ErrorID {
            //成功
            Success = 0,
            //失败
            Failed = 1,
            //不在该世界
            NotInTheWorld = 2,
            //该世界不存在
            WorldNotAlive = 3,
        }

        //[ProtoMember(1)] public ErrorID errorID;
        ////世界Id
        //[ProtoMember(2)] public ulong WorldId = 0;
        ////聊天消息列表
        //[ProtoMember(3)] public List<stWorldChatItem> ChatItems = new List<stWorldChatItem>();
    }

    /// <summary>
    /// 发送世界聊天信息请求
    /// </summary>
    //[ProtoContract]
    //public class SendWorldChatReq : ProtoBody {
    //    [ProtoMember(1)] public string SendContent = string.Empty;
    //}

    /// <summary>
    /// 发送世界聊天信息返回
    /// </summary>
    public class SendWorldChatRsp  {
        public enum ErrorID {
            //成功
            Success = 0,
            //失败
            Failed = 1,
            //不在该世界
            NotInTheWorld = 2,
            //该世界不存在
            WorldNotAlive = 3,
            //发送内容为空
            SendContentEmpty = 4,
        }

        //[ProtoMember(1)] public ErrorID errorID;
        ////世界Id
        //[ProtoMember(2)] public ulong WorldId = 0;
        ////聊天条目
        //[ProtoMember(3)] public stWorldChatItem ChatItem = new stWorldChatItem();
    }

    ///// <summary>
    ///// 发送世界聊天信息通知
    ///// </summary>
    //[ProtoContract]
    //public class SendWorldChatNtf : ProtoBody {
    //    //世界Id
    //    [ProtoMember(1)] public ulong WorldId = 0;
    //    //聊天条目
    //    [ProtoMember(2)] public stWorldChatItem ChatItem = new stWorldChatItem();
    //}

    #endregion

    #region 同步信息


    ///// <summary>
    ///// 刷新同步信息请求
    ///// </summary>
    //[ProtoContract]
    //public class UpdateSyncInfoReq : ProtoBody {
    //    //位置信息
    //    [ProtoMember(1)] public stVec3 Pos = new stVec3();
    //    //欧拉角
    //    [ProtoMember(2)] public stVec3 Euler = new stVec3();
    //}

    /// <summary>
    /// 刷新同步信息返回
    /// </summary>
    public class UpdateSyncInfoRsp {
        public enum ErrorID {
            //成功
            Success = 0,
            //失败
            Failed = 1,
            //不在该世界
            NotInTheWorld = 2,
            //该世界不存在
            WorldNotAlive = 3,
        }

        //[ProtoMember(1)] public ErrorID errorID;
        ////世界Id
        //[ProtoMember(2)] public ulong WorldId = 0;
        ////位置信息
        //[ProtoMember(3)] public stVec3 Pos = new stVec3();
        ////欧拉角
        //[ProtoMember(4)] public stVec3 Euler = new stVec3();
    }

    ///// <summary>
    ///// 刷新同步信息请求
    ///// </summary>
    //[ProtoContract]
    //public class UpdateSyncInfoNtf : ProtoBody {
    //    //用户Id
    //    [ProtoMember(1)] public ulong UserId = 0;
    //    //世界Id
    //    [ProtoMember(2)] public ulong WorldId = 0;
    //    //位置信息
    //    [ProtoMember(3)] public stVec3 Pos = new stVec3();
    //    //欧拉角
    //    [ProtoMember(4)] public stVec3 Euler = new stVec3();
    //}

    /// <summary>
    /// 刷新同步跳跃信息返回
    /// </summary>
    public class UpdateJumpInfoRsp
    {
        public enum ErrorID
        {
            //成功
            Success = 0,
            //失败
            Failed = 1,
            //不在该世界
            NotInTheWorld = 2,
            //该世界不存在
            WorldNotAlive = 3,
        }

        //[ProtoMember(1)] public ErrorID errorID;
        ////世界Id
        //[ProtoMember(2)] public ulong WorldId = 0;
        ////位置信息
        //[ProtoMember(3)] public stVec3 Pos = new stVec3();
        ////欧拉角
        //[ProtoMember(4)] public stVec3 Euler = new stVec3();
    }
    #endregion

    #region 获取世界玩家列表

    ///// <summary>
    ///// 世界玩家条目
    ///// </summary>
    //[ProtoContract]
    //public class stWorldPlayerItem
    //{
    //    //用户Id
    //    [ProtoMember(1)] public ulong UserId = 0;
    //    //位置
    //    [ProtoMember(2)] public stVec3 Pos = new stVec3();
    //    //角度
    //    [ProtoMember(3)] public stVec3 Euler = new stVec3();
    //    //性别
    //    [ProtoMember(4)] public ERoleSex Sex = ERoleSex.Other;
    //    //装扮
    //    [ProtoMember(5)] public List<uint> PartIds = new List<uint>();
    //}

    ///// <summary>
    ///// 获取世界玩家列表请求
    ///// </summary>
    //[ProtoContract]
    //public class GetWorldPlayerListReq : ProtoBody {

    //}

    /// <summary>
    /// 获取世界玩家列表返回
    /// </summary>
    public class GetWorldPlayerListRsp {
        public enum ErrorID {
            //成功
            Success = 0,
            //失败
            Failed = 1,
            //不在该世界
            NotInTheWorld = 2,
            //该世界不存在
            WorldNotAlive = 3,
        }

        //[ProtoMember(1)] public ErrorID errorID;
        ////世界Id
        //[ProtoMember(2)] public ulong WorldId = 0;
        ////玩家列表
        //[ProtoMember(3)] public List<stWorldPlayerItem> PlayerItems = new List<stWorldPlayerItem>();
    }


    #endregion
}
